#ifndef _FRAMERATE_HH_
#define _FRAMERATE_HH_

#include <cstdint>

class framerate_meter {
    int       ts_cap_;
    uint32_t* ts_;          // circular buffer of timestamps
    int       start_, end_; // circular buffer positions.
    uint32_t  window_;

    // NB. (start_ == end_) is an empty buffer.

public:
    enum { DEFAULT_TIMESTAMPS_CAP = 512 };

    framerate_meter(uint32_t window_size)
        : ts_cap_(DEFAULT_TIMESTAMPS_CAP)
        , ts_(new uint32_t[DEFAULT_TIMESTAMPS_CAP])
        , start_(0)
        , end_(0)
        , window_(window_size)
    { }

    ~framerate_meter() { delete[] ts_; }

    uint32_t tick(uint32_t now);
    float    framerate();
};

#endif // _FRAMERATE_HH_
