#ifndef _SDLUTIL_HH_
#define _SDLUTIL_HH_

#include "px/px.hh"

#include <memory>
#include "SDL.h"

#ifndef NO_SDL_TTF
#include "SDL_ttf.h"
#endif

struct surface_deleter {
    void operator()(SDL_Surface* surf) const { SDL_FreeSurface(surf); }
};
typedef std::unique_ptr<SDL_Surface, surface_deleter> unique_surface_ptr;

#ifndef NO_SDL_TTF
struct font_deleter {
    void operator()(TTF_Font* font) const { TTF_CloseFont(font); }
};
typedef std::unique_ptr<TTF_Font, font_deleter> unique_font_ptr;
#endif

bool sdlutil_init(const char** error);
std::unique_ptr<px::buffer<px::vec3> > load_rgb(
    const char* filename, const char **err);

#endif // _SDLUTIL_HH_
